; ==== banking ====
.memorymap
defaultslot 0
slotsize $8000
slot 0 $0000
.endme

.rombankmap
bankstotal 1
banksize $8000
banks 1
.endro

.computesmschecksum

.sdsctag 1.0,"SMS_Demo","SMS_Demo","Grz-"

; ==== Boot section ====
.bank 0 slot 0
.org $0001

    di
    im 1
    jp main

; ==== pause ====
.org $0066
	retn

; ==== main ====
main:
    ld sp, $dff0
	
    ld hl,VdpData
    ld b,VdpDataEnd-VdpData
    ld c,$bf
    otir

	; ==== clear vram ====
    ld hl,$4000 
    call VRAMToHL 
	call ClrVRAM
	
	call LoadLogo
	
    ; ==== display ====
    ld a,%11000000
	
    out ($bf),a
    ld a,$81
    out ($bf),a	

	; setup raster bar beginning position
	ld b, 190/2-64/2
	loop:

		ld a, b
		cp 140;182
		jr nz, ChangeSign
		
		ld c, 1
		jp jumpMain
			
		ChangeSign:
			cp 40
			jr nz, jumpMain
		
		ld c, 0
		
		jumpMain:
		
		ld a, c
		cp 1
		jr nz, plus
		
			dec b
		jp display
		
		plus:
			inc b

		display:
        call WaitVBL ; display it
		
		-:
			in a,($BF)
			and $80
		
		jp z,-
		
		jp loop

; raster bar effect
WaitVBL:	
		ld hl,RasterLogo
		ld e, RasterLogoEnd-RasterLogo
		; wait the beginning line
		WaitLine: 
			-:
				in a, ($BF)
				bit 7,a
			jr nz, -
			
			ld a, (hl)
			; fill the rest with black color
			push hl
				ld hl,$C009
				call VRAMToHL
				out ($be),a
			pop hl
			
			;ld a, (hl)
			;out ($be),a
			
			inc hl
			dec e
		
			ld a,e
			jr nz, nocha

			ld hl,RasterLogo
			ld e, RasterLogoEnd-RasterLogo
			
			nocha:
				in a, ($7E) 
				cp b
		jr nz, WaitLine
		
		; load first color
		push bc
		ld hl,Raster
		ld b,RasterEnd-Raster
		
		rasterLoop:
	
		; wait the next line to avoid flickers
		WaitNextLine:
			;in a, ($7E)
			;add a,b
			;xor a
			in a, ($BF)
			bit 7,a
		jr nz, WaitNextLine
		
		ld a,(hl)

		; change the first color in the palette
		push hl
			ld hl,$C009
			call VRAMToHL
			out ($be),a
		pop hl
						
		inc hl ; go to the next color value

		ld a,b
		out ($bf),a
		ld a,%10001000
		out ($bf),a

		; get actual scanline
		;in a, ($7E)
		;ld d,a
		
		djnz rasterLoop ; loop over all stored colors
		
		pop bc

		ret

.include "utils.inc"
.include "part1.inc"

; ==== data ====
; VDP data
VdpData:
.db $04,$80,$84,$81,$ff,$82,$ff,$85,$ff,$86,$ff,$87,$00,$88,$00,$89,$ff,$8a
VdpDataEnd:

; raster colors data
Raster:
.db $01, $02, $03, $3F, $07, $03, $13, $12, $02, $01
RasterEnd:

RasterLogo: 
;.db $10, $20, $30, $34, $38, $3C, $3d, $3e, $3f, $3e, $3d, $c, $38, $34, $30, $20, $10
.db $01, $02, $03, $04, $05, $06, $07, $08, $09, $0A, $0B, $0C, $0D, $0E, $0F, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $1A, $1B, $1C, $1D, $1E, $1F, $20, $21, $22, $23, $24, $25, $26, $27, $28, $29, $2A, $2B, $2C, $2D, $2E, $2F, $30, $31, $32, $33, $34, $35, $36, $37, $38, $39, $3A, $3B, $3C, $3D, $3E, $3F
RasterLogoEnd:

.include "gfx/genesia.inc"